/*
    GDAM - Geoff & Dave's Audio Mixer
    Copyright (C) 1999    Mike Radford, Dave Benson, Geoff Matters.

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

    Contact:
        daveb@ffem.org <Dave Benson>
        geoff@ugcs.caltech.edu <Geoff Matters>
	mrad@blorf.com <Mike Radford>
*/
#ifndef __GDAM_PINK_NOISE_H_
#define __GDAM_PINK_NOISE_H_

#include <gdam/gdamsource.h>

typedef struct _GdamPinkNoise GdamPinkNoise;
typedef struct _GdamPinkNoiseClass GdamPinkNoiseClass;

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

GtkType gdam_pink_noise_get_type();
#define GDAM_TYPE_PINK_NOISE			(gdam_pink_noise_get_type ())
#define GDAM_PINK_NOISE(obj)              (GTK_CHECK_CAST ((obj), GDAM_TYPE_PINK_NOISE, GdamPinkNoise))
#define GDAM_PINK_NOISE_CLASS(klass)      (GTK_CHECK_CLASS_CAST ((klass), GDAM_TYPE_PINK_NOISE, GdamPinkNoiseClass))
#define GDAM_IS_NOISE(obj)           (GTK_CHECK_TYPE ((obj), GDAM_TYPE_PINK_NOISE))
#define GDAM_IS_NOISE_CLASS(klass)   (GTK_CHECK_CLASS_TYPE ((klass), GDAM_TYPE_PINK_NOISE))

struct _GdamPinkNoiseClass {
	GdamSourceClass		noise_class;
};

#define PINK_MAX_RANDOM_ROWS   (30)
#define PINK_RANDOM_BITS       (24)
#define PINK_RANDOM_SHIFT      ((sizeof(long)*8)-PINK_RANDOM_BITS)

struct _GdamPinkNoise {
	GdamSource		noise;
	unsigned short int	random_state[3];
	long int 		pink_Rows[PINK_MAX_RANDOM_ROWS];
	long int 		pink_RunningSum;
	int      		pink_Index;
	int      		pink_IndexMask;
	double   		pink_Scalar;
	int 			numRows;
};

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
